on maxprint printType
  global gPropFont, printer
  cursor(4)
  set gPropFont to "times new roman"
  openXLib("pmatic.dll")
  set printer to PrintOMatic(mnew)
  printer(mRegister, "pmat130-067-01107")
  printer(mReset)
  if printType = "map" then
    printmap()
  else
    if printType = "tour" then
      printTour()
    else
      if printType = "text" then
        printText()
      end if
    end if
  end if
  printer(mdispose)
  closeXLib("pmatic.dll")
  cursor(-1)
end

on printmap
  global w, h, print
  if item 5 of field "MaxField" = "metro" then
    printer(mSetLandScapemode, 1)
  else
    printer(mSetLandScapemode, 0)
  end if
  set mapToPrint to the value of item 1 of field "MaxField"
  set w to printer(mGetPageWidth)
  set h to printer(mGetPageheight)
  set mapName to item 4 of field "maxfield"
  printer(mSetMargins, 1, 1, 1, 1)
  printer(mSetTextStyle, "bold,underline")
  set halve to printer(mGetPaperWidth) / 2
  printer(mSetTextSize, 24)
  printer(mSetTextJust, "centered")
  printer(mdrawText, mapName, halve, 40)
  printer(mNewPage)
  if item 5 of field "MaxField" = "metro" then
    AppendBitMap(mapToPrint, 1, 55, "metro")
  else
    AppendBitMap(mapToPrint, 1, 55, "map")
  end if
  if item 2 of field "MaxField" > -1 then
    set arrowx to the value of item 2 of field "MaxField"
    set arrowy to the value of item 3 of field "MaxField"
    AppendBitMap("arrow", arrowx, arrowy, "arrow")
  end if
  printingProc()
end

on AppendBitMap TheBitMap, left, top, whatToPrint
  global w, h, print, forArrowTop, forArrowLeft, prop
  set y to the height of cast TheBitMap
  set x to the width of cast TheBitMap
  if whatToPrint = "tour" then
    if x > (w - 5) then
      set x to w - 5
      set y to (y * w / x) + 30
    end if
  else
    if whatToPrint = "map" then
      set oldY to y
      set oldX to x
      set y to printer(mGetPageheight) - top - 60
      set x to (oldX * y / oldY) + 0.0
      set prop to y / (oldY + 0.0)
      set left to (printer(mGetPageWidth) / 2.0) - (x / 2.0)
      set x to left + x
      set y to top + y
      set forArrowTop to top
      set forArrowLeft to left
      set left to integer(left)
      set x to integer(x)
    else
      if whatToPrint = "metro" then
        set oldY to y
        set oldX to x
        set x to printer(mGetPageWidth)
        set y to (oldY * x / oldX) + 0.0
        set prop to x / (oldX + 0.0)
        set top to (printer(mGetPageheight) / 2.0) - (y / 2.0)
        set x to left + x
        set y to top + y
        set forArrowTop to top
        set forArrowLeft to left
        set top to integer(top)
        set y to integer(y)
      else
        if whatToPrint = "arrow" then
          set left to left * prop
          set top to top * prop
          if item 5 of field "MaxField" = "metro" then
          end if
          set left to integer(left - (x / 2) + forArrowLeft)
          set top to integer(top - y + forArrowTop)
          set top to top - 7
          set x to integer(left + x)
          set y to integer(top + y)
        end if
      end if
    end if
  end if
  printer(mPicture, the picture of member TheBitMap, left, top, x, y)
  if whatToPrint = "tour" then
  end if
end

on printText
  global w, h, gPropFont, printer
  printer(mSetMargins, 72, 72, 72, 72)
  set w to printer(mGetPageWidth)
  set h to printer(mGetPageheight)
  MySetUp()
  printer(mNewPage)
  printer(mTextBox, 22, 42, w, h, 0)
  repeat with cnt = 1 to the number of lines in field "MaxField"
    set CastToPrint to integer(the value of item 1 of line cnt of field "Maxfield")
    AppendStyledText(printer, CastToPrint, 1)
  end repeat
  printingProc()
end

on printTour
  global printer
  set w to printer(mGetPageWidth)
  set h to printer(mGetPageheight)
  MySetUp()
  printer(mNewPage)
  set mapName to line 1 of field "maxfield"
  printer(mSetMargins, 1, 1, 1, 1)
  printer(mSetTextStyle, "bold,underline")
  set halve to printer(mGetPaperWidth) / 2
  printer(mSetTextSize, 24)
  printer(mSetTextJust, "left")
  printer(mdrawText, mapName, 35, 55)
  set whatToPrint to "tour"
  set TheBitMap to the value of line 2 of field "MaxField"
  AppendBitMap(TheBitMap, 235, 70, "tour")
  printer(mSetTextJust, "left")
  printer(mSetTextStyle, "plain")
  printer(mTextBox, 35, 60, w, h, 1)
  printer(mSetTextSize, 16)
  repeat with i = 3 to the number of lines in field "MaxField"
    set tourtext to line i of field "MaxField"
    AppendStyledText(printer, the value of tourtext, 1)
  end repeat
  printingProc()
end

on MySetUp
  global printer, w, h, gPropFont
  printer(mSetLandScapemode, 0)
  printer(mSetMargins, 72, 72, 72, 72)
  set w to printer(mGetPageWidth)
  set h to printer(mGetPageheight)
  printer(mSetTextFont, gPropFont)
  printer(mSetTextSize, 12)
  printer(mSetTextStyle, "italic")
  printer(mSetPageNumSymbol, "Þ")
  printer(mSetTextJust, "left")
  printer(mdrawText, "Cocktails", 22, 35)
  printer(mSetTextJust, "right")
  printer(mdrawText, "page Þ", w, 35)
  printer(mLine, 22, 38, w, 38)
  printer(mSetTextJust, "left")
  printer(mSetTextStyle, "plain")
end

on AppendStyledText obj, theCast, autoAppend
  if not objectp(obj) then
    exit
  end if
  if not integerp(theCast) and not stringp(theCast) then
    exit
  end if
  if not integerp(autoAppend) then
    set autoAppend to 0
  end if
  set styleList to BuildStyleList1(theCast)
  repeat with cnt = 1 to count(styleList)
    set styleRun to getAt(styleList, cnt)
    obj(mSetTextFont, getaProp(styleRun, #font))
    obj(mSetTextSize, getaProp(styleRun, #size))
    obj(mSetTextStyle, getaProp(styleRun, #style))
    set charsAdded to obj(mAppendText, char getaProp(styleRun, #start) to getaProp(styleRun, #end) of field theCast, autoAppend)
    if charsAdded = 0 then
      exit
    end if
  end repeat
end

on BuildStyleList theCast
  global printSource, tournumber
  if printSource = "tours" then
    set diff to 500
  else
    if printSource = "general" then
      set diff to 7140
    else
      if printSource = "objects" then
        set diff to 120
      end if
    end if
  end if
  if (the name of cast theCast = "maxspace") or (the name of cast theCast = "maxfield2") or (the name of cast theCast = "theEmpty") then
    set styleList to BuildStyleList1(theCast)
  else
    if printSource = "tours" then
      put theCast + 20
      set styleList to the value of the text of cast (theCast + 20)
    else
      if (printSource = "objects") and (theCast > 366) then
        set styleList to the value of line theCast - 366 of field "stylelists3"
      else
        if (printSource = "objects") and (theCast > 275) then
          set styleList to the value of line theCast - 275 of field "stylelists2"
        else
          if (printSource = "general") and ((theCast - diff) > 35) then
            set styleList to the value of line theCast - diff - 35 of field "Stylelists2"
          else
            set styleList to the value of line theCast - diff of field "stylelists"
          end if
        end if
      end if
    end if
  end if
  return styleList
end

on BuildStyleList1 theCast
  set styleList to []
  set curFont to EMPTY
  set curSize to 0
  set curStyle to EMPTY
  repeat with cnt = 1 to the number of chars in the text of member theCast
    if (the textFont of char cnt of field theCast <> curFont) or (the textSize of char cnt of field theCast <> curSize) or (the textStyle of char cnt of field theCast <> curStyle) then
      if count(styleList) then
        setaProp(getAt(styleList, count(styleList)), #end, cnt - 1)
      end if
      set curFont to the textFont of char cnt of member theCast
      set curSize to the textSize of char cnt of member theCast
      set curStyle to the textStyle of char cnt of member theCast
      add(styleList, [#font: curFont, #size: curSize, #style: curStyle, #start: cnt, #end: cnt])
    end if
  end repeat
  if count(styleList) then
    setaProp(getAt(styleList, count(styleList)), #end, the number of chars in the text of member theCast)
  end if
  return styleList
end

on printingProc
  if the controlDown then
    printer(mPrintPreview)
  else
    printer(mPrint)
  end if
end

on fontSalvation firstcast, lastcast
  set counter to 0
  repeat with i = firstcast to lastcast
    put i
    set counter to counter + 1
    if the castType of cast i = #text then
      if char the number of chars in the name of cast i of the name of cast i = "G" then
        set x to BuildStyleList1(i)
      else
        set x to " "
      end if
    end if
    put x into line counter of field "stylelists"
  end repeat
end

on xxx
  repeat with i = 1 to the number of lines in field "stylelists"
    put i && char 1 to 6 of line i of field "stylelists" && the name of cast (i + 120)
  end repeat
end

on mapsmats
  set counter to 1
  set mapheight to 0
  set mapwidth to 0
  repeat with i = 1 to 5
    repeat with j = 1 to 4
      set mw to the width of cast "map" & counter
      set mh to the height of cast "map" & counter
      set mapwidth to mw + mapwidth
      put integer(mapwidth) && integer(mapheight) into line counter of field "mapsmats"
      set counter to counter + 1
    end repeat
    set mapheight to mapheight + 698
    set mapwidth to 0
  end repeat
end

on fontSalvation2 firstcast, lastcast
  set counter to 0
  repeat with i = firstcast to lastcast
    put i
    set counter to counter + 1
    if the castType of cast i = #text then
      if char the number of chars in the name of cast i of the name of cast i = "G" then
        set x to BuildStyleList1(i)
      else
        set x to " "
      end if
    end if
    put x into line counter of field "stylelists"
    set fff to the number of chars in field "stylelists"
    put fff
    if fff > 32000 then
      exit repeat
    end if
  end repeat
end

on tourproblem x, y
  repeat with i = x to y
    set fontlist to BuildStyleList1(i)
    put fontlist into line 1 of field (i + 20)
  end repeat
end
